Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
OccluderEffect Class Reference

This functions similarly to a LightAttrib or ClipPlaneAttrib. More...

`#include "occluderEffect.h"`

Inheritance diagram for OccluderEffect:

## Public Member Functions
ConstPointerTo< RenderEffect > | add_on_occluder (const NodePath &occluder) const
| Returns a new OccluderEffect, just like this one, but with the indicated occluder added to the list of occluders enabled by this effect.
virtual int | complete_pointers (TypedWritable **plist, BamReader *manager)
| Receives an array of pointers, one for each time manager->read_pointer() was called in fillin().
virtual TypeHandle | force_init_type ()
int | get_num_on_occluders () const
NodePath | get_on_occluder (int n) const
virtual TypeHandle | get_type () const
bool | has_on_occluder (const NodePath &occluder) const
| Returns true if the indicated occluder is enabled by the effect, false otherwise.
bool | is_identity () const
| Returns true if this is an identity effect: it does not change the set of occluders in use.
virtual void | output (std::ostream &out) const
ConstPointerTo< RenderEffect > | remove_on_occluder (const NodePath &occluder) const
| Returns a new OccluderEffect, just like this one, but with the indicated occluder removed from the list of occluders enabled by this effect.
virtual bool | require_fully_complete () const
| Some objects require all of their nested pointers to have been completed before the objects themselves can be completed.
virtual void | write_datagram (BamWriter *manager, Datagram &dg)
| Writes the contents of this object to the datagram for shipping out to a Bam file.
Public Member Functions inherited from RenderEffect
| RenderEffect (const RenderEffect &copy)=delete
virtual | ~RenderEffect ()
| The destructor is responsible for removing the RenderEffect from the global set if it is there.
virtual void | adjust_transform (ConstPointerTo< TransformState > &net_transform, ConstPointerTo< TransformState > &node_transform, const PandaNode *node) const
| Performs some operation on the node's apparent net and/or local transforms.
int | compare_to (const RenderEffect &other) const
| Provides an arbitrary ordering among all unique RenderEffects, so we can store the essentially different ones in a big set and throw away the rest.
virtual void | cull_callback (CullTraverser *trav, CullTraverserData &data, ConstPointerTo< TransformState > &node_transform, ConstPointerTo< RenderState > &node_state) const
| If has_cull_callback() returns true, this function will be called during the cull traversal to perform any additional operations that should be performed at cull time.
virtual void | finalize (BamReader *manager)
| Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed.
virtual bool | has_adjust_transform () const
| Should be overridden by derived classes to return true if adjust_transform() has been defined, and therefore the RenderEffect has some effect on the node's apparent local and net transforms.
virtual bool | has_cull_callback () const
| Should be overridden by derived classes to return true if cull_callback() has been defined.
RenderEffect & | operator= (const RenderEffect &copy)=delete
virtual ConstPointerTo< TransformState > | prepare_flatten_transform (const TransformState *net_transform) const
| Preprocesses the accumulated transform that is about to be applied to (or through) this node due to a flatten operation.
virtual bool | safe_to_combine () const
| Returns true if this kind of effect can safely be combined with sibling nodes that share the exact same effect, or false if this is not a good idea.
virtual bool | safe_to_transform () const
| Returns true if it is generally safe to transform this particular kind of RenderEffect by calling the xform() method, false otherwise.
virtual void | write (std::ostream &out, int indent_level) const
virtual ConstPointerTo< RenderEffect > | xform (const LMatrix4 &mat) const
| Returns a new RenderEffect transformed by the indicated matrix.
Public Member Functions inherited from TypedWritableReferenceCount
| TypedWritableReferenceCount (const TypedWritableReferenceCount &copy)
virtual ReferenceCount * | as_reference_count ()
| Returns the pointer cast to a ReferenceCount pointer, if it is in fact of that type.
void | operator= (const TypedWritableReferenceCount &copy)
Public Member Functions inherited from TypedWritable
| TypedWritable (const TypedWritable &copy)
vector_uchar | encode_to_bam_stream () const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and returns that data as a bytes object.
bool | encode_to_bam_stream (vector_uchar &data, BamWriter *writer=nullptr) const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and stores that data in the indicated string.
UpdateSeq | get_bam_modified () const
| Returns the current bam_modified counter.
void | mark_bam_modified ()
| Increments the bam_modified counter, so that this object will be invalidated and retransmitted on any open bam streams.
void | operator= (const TypedWritable &copy)
virtual void | update_bam_nested (BamWriter *manager)
| Called by the BamWriter when this object has not itself been modified recently, but it should check its nested objects for updates.
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
static ConstPointerTo< RenderEffect > | make ()
| Constructs a new OccluderEffect object that does nothing.
static void | register_with_read_factory ()
| Tells the BamReader how to create objects of type OccluderEffect.
Static Public Member Functions inherited from RenderEffect
static TypedWritable * | change_this (TypedWritable *old_ptr, BamReader *manager)
| Called immediately after complete_pointers(), this gives the object a chance to adjust its own pointer if desired.
static TypeHandle | get_class_type ()
static int | get_num_effects ()
| Returns the total number of unique RenderEffect objects allocated in the world.
static void | init_type ()
static void | list_effects (std::ostream &out)
| Lists all of the RenderEffects in the cache to the output stream, one per line.
static bool | validate_effects ()
| Ensures that the cache is still stored in sorted order.
Static Public Member Functions inherited from TypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (TypedWritableReferenceCount) decode_from_bam_stream(vector_uchar data
Static Public Member Functions inherited from TypedWritable
static bool | decode_raw_from_bam_stream (TypedWritable *&ptr, ReferenceCount *&ref_ptr, vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts the single object on those bytes.
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Public Attributes
| get_num_on_occluders
| Returns the number of occluders that are enabled by the effectute.
| get_on_occluder
| Returns the nth occluder enabled by the effectute, sorted in render order.
Public Attributes inherited from TypedWritableReferenceCount
static BamReader * | reader = nullptr)
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.

## Additional Inherited Members
Static Public Attributes inherited from TypedWritable
static TypedWritable *const | Null = nullptr

## Detailed Description

This functions similarly to a LightAttrib or ClipPlaneAttrib.

It indicates the set of occluders that modify the geometry at this level and below. Unlike a ClipPlaneAttrib, an OccluderEffect takes effect immediately when it is encountered during traversal, and thus can only add occluders; it may not remove them.

Definition at line 32 of file occluderEffect.h.

## Member Function Documentation

## ◆ add_on_occluder()

ConstPointerTo< RenderEffect > OccluderEffect::add_on_occluder | ( | const NodePath & | occluder | ) | const

Returns a new OccluderEffect, just like this one, but with the indicated occluder added to the list of occluders enabled by this effect.

Definition at line 45 of file occluderEffect.cxx.

References NodePath::is_empty(), TypedObject::is_of_type(), and NodePath::node().

Referenced by NodePath::set_occluder().

## ◆ complete_pointers()

int OccluderEffect::complete_pointers | ( | TypedWritable ** | p_list,
|  | BamReader * | manager )
| virtual

Receives an array of pointers, one for each time manager->read_pointer() was called in fillin().

Returns the number of pointers processed.

Reimplemented from TypedWritable.

Definition at line 163 of file occluderEffect.cxx.

References TypedWritable::complete_pointers(), AttribNodeRegistry::find_node(), BamReader::get_file_minor_ver(), and AttribNodeRegistry::get_node.

## ◆ force_init_type()

virtual TypeHandle OccluderEffect::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from RenderEffect.

Definition at line 89 of file occluderEffect.h.

## ◆ get_class_type()

static TypeHandle OccluderEffect::get_class_type | ( |  | ) |
| inline static

Definition at line 78 of file occluderEffect.h.

## ◆ get_type()

virtual TypeHandle OccluderEffect::get_type | ( |  | ) | const
| inline virtual

Reimplemented from RenderEffect.

Definition at line 86 of file occluderEffect.h.

## ◆ has_on_occluder()

bool OccluderEffect::has_on_occluder | ( | const NodePath & | occluder | ) | const
| inline

Returns true if the indicated occluder is enabled by the effect, false otherwise.

Definition at line 53 of file occluderEffect.I.

Referenced by NodePath::has_occluder().

## ◆ init_type()

static void OccluderEffect::init_type | ( |  | ) |
| inline static

Definition at line 81 of file occluderEffect.h.

## ◆ is_identity()

bool OccluderEffect::is_identity | ( |  | ) | const
| inline

Returns true if this is an identity effect: it does not change the set of occluders in use.

Definition at line 62 of file occluderEffect.I.

## ◆ make()

ConstPointerTo< RenderEffect > OccluderEffect::make | ( |  | ) |
| static

Constructs a new OccluderEffect object that does nothing.

Definition at line 30 of file occluderEffect.cxx.

Referenced by NodePath::set_occluder().

## ◆ output()

void OccluderEffect::output | ( | std::ostream & | out | ) | const
| virtual

Reimplemented from RenderEffect.

Definition at line 68 of file occluderEffect.cxx.

## ◆ register_with_read_factory()

void OccluderEffect::register_with_read_factory | ( |  | ) |
| static

Tells the BamReader how to create objects of type OccluderEffect.

Definition at line 130 of file occluderEffect.cxx.

References BamReader::get_factory(), and Factory< Type >::register_factory().

Referenced by init_libpgraph().

## ◆ remove_on_occluder()

ConstPointerTo< RenderEffect > OccluderEffect::remove_on_occluder | ( | const NodePath & | occluder | ) | const

Returns a new OccluderEffect, just like this one, but with the indicated occluder removed from the list of occluders enabled by this effect.

Definition at line 57 of file occluderEffect.cxx.

References NodePath::is_empty(), TypedObject::is_of_type(), and NodePath::node().

Referenced by NodePath::clear_occluder().

## ◆ require_fully_complete()

bool OccluderEffect::require_fully_complete | ( |  | ) | const
| virtual

Some objects require all of their nested pointers to have been completed before the objects themselves can be completed.

If this is the case, override this method to return true, and be careful with circular references (which would make the object unreadable from a bam file).

Reimplemented from TypedWritable.

Definition at line 206 of file occluderEffect.cxx.

## ◆ write_datagram()

void OccluderEffect::write_datagram | ( | BamWriter * | manager,
|  | Datagram & | dg )
| virtual

Writes the contents of this object to the datagram for shipping out to a Bam file.

Reimplemented from RenderEffect.

Definition at line 139 of file occluderEffect.cxx.

References Datagram::add_uint16(), BamWriter::get_file_minor_ver(), get_num_on_occluders, RenderEffect::write_datagram(), and BamWriter::write_pointer().

## Member Data Documentation

## ◆ get_num_on_occluders

int OccluderEffect::get_num_on_occluders
| inline

Returns the number of occluders that are enabled by the effectute.

Definition at line 42 of file occluderEffect.h.

Referenced by CullPlanes::apply_state(), and write_datagram().

## ◆ get_on_occluder

NodePath OccluderEffect::get_on_occluder
| inline

Returns the nth occluder enabled by the effectute, sorted in render order.

Definition at line 42 of file occluderEffect.h.

Referenced by CullPlanes::apply_state().

The documentation for this class was generated from the following files:

- panda/src/pgraph/occluderEffect.h
- panda/src/pgraph/occluderEffect.cxx
- panda/src/pgraph/occluderEffect.I